# **References**

## *Branch and Bound*
- **Floudas, CA (2013)**. Deterministic global optimization: theory, methods and applications. Vol. 37. *Springer Science & Business Media*.
- **Horst, R, Tuy, H (2013)**. Global optimization: Deterministic approaches. *Springer Science & Business Media*.

## *Parametric Interval Techniques*
- **Hansen ER, Walster GW (2004)**. Global Optimization Using Interval Analysis. *Marcel Dekker, New York, second edition*.
- **Krawczyk R (1969)**. Newton-algorithmen zur bestimmung con nullstellen mit fehler-schranken. *Computing*, 4:187–201.
- **Krawczyk R (1984)**. Interval iterations for including a set of solutions. *Computing*, 32:13–31.
- **Miranda C (1940)**. Un’osservatione su un teorema di brower. *Boll. Un. Mat. Ital.*, 3:5–7.
- **Neumaier A (1990)**. Interval Methods for Systems of Equations. *Cambridge University Press*, Cambridge.
- **Moore RE (1977)**. A test for existence of solutions to nonlinear systems. *SIAM Journal on Numerical Analysis*, 14(4):611–615.

## *Domain Reduction*
- **Benhamou F, & Older WJ (1997)**. Applying interval arithmetic to real, integer, and boolean constraints. *The Journal of Logic Programming*, 32, 1–24.
- **Caprara A, & Locatelli M (2010)**. Global optimization problems and domain reduction strategies. *Mathematical Programming*, 125, 123–137.
- **Gleixner AM, Berthold T, Müller B, & Weltge S (2016)**. Three enhancements for optimization-based bound tightening. *ZIB Report*, 15–16.
- **Ryoo HS, & Sahinidis NV (1996)**. A branch-and-reduce approach to global optimization. *Journal of Global Optimization*, 8, 107–139.
- **Schichl H, & Neumaier A (2005)**. Interval analysis on directed acyclic graphs for global optimization. *Journal of Global Optimization*, 33, 541–562.
- **Tawarmalani, M, & Sahinidis, NV (2005)**. A polyhedral branch-and-cut approach to global optimization. *Mathematical Programming*, 103, 225–249.
- **Vu, X, Schichl, H, & Sam-Haroud, D (2009)**. Interval propagation and search on directed acyclic graphs for numerical constraint solving. *Journal of Global Optimization*, 45, 499–531.

## *Generalized McCormick Relaxations*
- **Chachuat, B (2014).** MC++: a toolkit for bounding factorable functions, v1.0. Retrieved 2 July 2014 https://projects.coin-or.org/MCpp
- **Mitsos A, Chachuat B, and Barton PI. (2009).** McCormick-based relaxations of algorithms. *SIAM Journal on Optimization*, 20(2):573–601.
- **McCormick, GP (1976).**. Computability of global solutions to factorable nonconvex programs: Part I-Convex underestimating problems. *Mathematical Programming*, 10:147–175.
- **McCormick, GP (1983)**. Nonlinear programming: Theory, Algorithms, and Applications. Wiley, New York.
- **Scott JK,  Stuber MD, and Barton PI. (2011).** Generalized McCormick relaxations. *Journal of Global Optimization*, 51(4):569–606.
- **Stuber MD, Scott JK, Barton PI (2015).** Convex and concave relaxations of implicit functions. *Optim. Methods Softw.* 30(3), 424–460
- **Tsoukalas A and Mitsos A (2014).** Multivariate McCormick Relaxations. *Journal of Global Optimization*, 59:633–662.
- **Khan KA, Watson HAJ, Barton PI (2017).** Differentiable McCormick relaxations. *Journal of Global Optimization*, 67(4):687-729.
- **Wechsung A, Scott JK, Watson HAJ, and Barton PI. (2015).** Reverse propagation of McCormick relaxations. *Journal of Global Optimization* 63(1):1-36.

## *Semi-Infinite Programming*
- **Mitsos A (2009).** Global optimization of semi-infinite programs via restriction of the right-hand side. *Optimization*, 60(10-11):1291-1308.
- **Stuber MD and Barton PI (2015).** Semi-Infinite Optimization With Implicit Functions. *Industrial & Engineering Chemistry Research*, 54:307-317, 2015.
